#ifndef ZW_ADDINGINTERVIEWDEVICE_FSM_H_
#define ZW_ADDINGINTERVIEWDEVICE_FSM_H_

#include <stdint.h>
#include <string.h>
#include "ZW_TransportEndpoint.h"
#include "ZW_AutoRemoveAdd_FSM.h"
#include "serialAPI.h"
#include "utils.h"
#include "timer.h"
#include "cmd_class_misc.h"
#include "zw_api.h"
#include "config.h"

#include "zw_serialapi/zw_serialapi.h"
#include "zw_serialapi/zw_classcmd.h"

#define REQUEST_NIF_TIMEOUT                 (10000) /*10 seconds */
#define WAITING_SEND_REQ_NIF                (2000)  /*2 seconds */
#define INTERVIEW_SUCCESS                   1
#define INTERVIEW_FAIL                      0
#define INTERVIEW_DEVICE_STATE              enum INTERVIEW_DEVICE_FSM_STATES

//States
typedef enum INTERVIEW_DEVICE_FSM_STATES 
{
    ST_INTERVIEW_IDLE = 0,
    ST_AWAIT_ZWAVEPLUS_INFO_REPORT = 1,
    ST_AWAIT_ASSOCIATION_COMPL = 2,
    ST_AWAIT_ASSIGN_ROUTE_COMPL = 3,
    ST_AWAIT_MULTICHANNEL_REPORT = 4,
    ST_AWAIT_CAP_REPORT_OF_EP = 5,
    ST_AWAIT_CAP_REPORT_OF_NEXT_EP = 6,
    ST_AWAIT_SET_WAKEUP_COMPL = 7,
    ST_AWAIT_MANU_SPECIFIC_REPORT = 8,
    ST_INTERVIEW_DEVICE_SUCCESS = 9,
    ST_INTERVIEW_DEVICE_FAIL = 10,
    ST_AWAIT_MANU_SPECIFIC_REPORT_TIME_2 = 11,
    ST_AWAIT_MEMBER_REPORT_OF_NEXT_AGG_EP = 12,
    ST_AWAIT_CAP_SECURE_V0_REPORT_OF_EP = 13,
    ST_AWAIT_CAP_SECURE_V0_REPORT_OF_NEXT_EP = 14,
    ST_AWAIT_CAP_SECURE_V2_REPORT_OF_EP = 15,
    ST_AWAIT_CAP_SECURE_V2_REPORT_OF_NEXT_EP = 16,
}INTERVIEW_DEVICE_FSM_STATE_T;

//Events
typedef enum INTERVIEW_DEVICE_FSM_EV
{
    EV_ADD_NODE_OK = 0,

    EV_ZWAVEPLUS_INFO_REPORT_OK,
    EV_NOT_SUPPORT_CC_ZWAVEPLUS,
    EV_ZWAVEPLUS_INFO_REPORT_NOT_OK,

    EV_SET_ASSOCIATION_COMPL_OK,
    EV_NOT_SUPPORT_CC_ASSOCIATION,
    EV_SET_ASSOCIATION_COMPL_NOT_OK,

    EV_ASSIGN_RETURN_ROUTE_COMPL_OK,
    EV_NOT_SUPPORT_CC_ASSIGN_ROUTE,
    EV_ASSIGN_RETURN_ROUTE_NOT_OK,

    EV_RECIEVE_END_POINT_REPORT_OK,
    EV_RECIEVE_END_POINT_REPORT_NOT_OK,
    EV_REPORT_CAPABILITY_EP_OK,
    EV_REPORT_CAPABILITY_EP_NOT_OK,
    EV_ALL_EP_REPORT_OK,
    EV_ALL_EP_REPORT_NOT_OK,
    EV_NOT_SUPPORT_CC_MULTI_CHANNEL,

    EV_AWAIT_MEMEBER_REPORT_OF_AGG_EP,
    EV_REPORT_MEMBER_AGG_EP_OK,

    EV_WAKEUP_SET_COMPL_OK,
    EV_NOT_SUPPORT_CC_WAKEUP,
    EV_WAKEUP_SET_COMPL_NOT_OK,

    EV_MANU_SPECIFIC_REPORT_OK,
    EV_NOT_SUPPORT_CC_MANU_SPECIFIC,
    EV_MANU_SPECIFIC_REPORT_NOT_OK,
    
    EV_INTERVIEW_DEVICE_FINISH,
    EV_TIMEOUT_STATE,
    EV_TIMEOUT_TIME_1,

    /*2017-10-16, Ep-S0_capability, Ep-S2_capability*/
    EV_REPORT_SECURE_V0_CAPABILITY_EP_OK,
    EV_REPORT_SECURE_V0_CAPABILITY_EP_NOT_OK,
    EV_REPORT_SECURE_V2_CAPABILITY_EP_OK,
    EV_REPORT_SECURE_V2_CAPABILITY_EP_NOT_OK,
    EV_ALL_EP_REPORT_SECURE_V0_CAPABILITY_OK,
    EV_ALL_EP_REPORT_SECURE_V0_CAPABILITY_NOT_OK,
    EV_ALL_EP_REPORT_SECURE_V2_CAPABILITY_OK,
    EV_ALL_EP_REPORT_SECURE_V2_CAPABILITY_NOT_OK,
    EV_EP_NOT_SUPPORT_CC_SECURE_V0,
    EV_EP_NOT_SUPPORT_CC_SECURE_V2,
    EV_EP_SUPPORT_CC_SECURE_V2,    
    EV_CLOSE_NWK,

}INTERVIEW_DEVICE_FSM_EV_T;

void InitInterviewDeviceFsm();
void SendGetZwaveInfo();
void PostEventInterviewDevice(INTERVIEW_DEVICE_FSM_EV_T ev);
INTERVIEW_DEVICE_FSM_STATE_T GetInterviewDeviceFsmState();


/*variable interview device */
extern  INTERVIEW_DEVICE_STATE state_interview;
/*variable for auto remove add */
extern STATE_AUTO_REMOVE_ADD state_auto_remove_add;

#endif /* ZW_ADDINGINTERVIEWDEVICE_FSM_H_ */